{-----------------------------------------------------------------------------
 Unit Ad : Unit1
 Yazar    : Karflake. Program gelitirirseniz ltfen karflake@yahoo.com'a atnz
 Ama     : Farkl bir satran notasyonu biimini PGN tipine dntrme
 Date     : 14.07.2003

-----------------------------------------------------------------------------}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    LstYahoo: TListBox;
    LstDene: TListBox;
    BtnDonustur: TButton;
    Label1: TLabel;
    Label2: TLabel;
    BtnYahooYukle: TButton;
    BtnKaydet: TButton;
    Ac: TOpenDialog;
    durum: TStringGrid;
    ChkBgoster: TCheckBox;
    ChBHizliCalis: TCheckBox;
    ChBHizliKaydet: TCheckBox;
    Kaydet: TSaveDialog;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    BtnTemizle: TButton;
    procedure BtnDonusturClick(Sender: TObject);
    function rok_kontrol(var cumle:string; beyazmi:boolean):boolean;
    function cok_oyun_isle(calisma_sayisi:word):boolean;
    procedure baslangic_konumu;
    procedure goster();
    function sutun_bul(yazi:string):byte;
    function beyaz_hamle(cumle:string):string;
    function siyah_hamle(cumle:string):string;
    procedure cevir();
    procedure BtnYahooYukleClick(Sender: TObject);
    procedure BtnKaydetClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnTemizleClick(Sender: TObject);

  private
    { Private declarations }
  public
    procedure hata(Sender: TOBject; E:Exception);
    { Public declarations }

  end;

var
  Form1: TForm1;
  tahta: array[1..8,1..8] of char;
  //satran tahtasnn tutulduu dizi
  i,j,k,sutun1,sutun2: byte;
  satir1,satir2: string[1];
  hamle: string;
  tut: char;
  oyun_sayisi,calisma:word;
  Oyunlar : TStringList;
  oyun_sirasi:array[1..100] of word;

implementation

{$R *.dfm}

procedure TForm1.hata(Sender: TOBject; E:Exception);
begin
//  Application.MessageBox('Programda bir hata olutu.'+#10
//    +'Ltfen program ktsn kontrol ediniz.', 'Uyar', MB_OK
//    +MB_ICONASTERISK+MB_DEFBUTTON1+MB_APPLMODAL);
  application.ShowException(E);
//Programda bir hata oluursa, hatann ne olduunu gstermek iin
end;


function tekrar_sayisi(var cumle:string; aranan:string; sil:boolean=false):byte;
var
  sayi: byte;  tut:string;
begin
  sayi:=0; tut:=cumle;
  while Pos(aranan,cumle)>0 do
  begin
    sayi:=sayi+1;
    if sil then
     delete(cumle,Pos(aranan,cumle),1)
    else
      cumle:=copy(cumle,Pos(aranan,cumle)+1,length(cumle)-Pos(aranan,cumle));
  end;
  if not sil then cumle:=tut;
  result:=sayi;
end;

procedure TForm1.baslangic_konumu();
var
  sutun:byte;
begin
  //Talarn balang konumu
  for i:=1 to 8 do for j:=1 to 8 do tahta[i,j]:=' ';
  for sutun:=1 to 8 do
  begin
    tahta[2,sutun]:='P';
    tahta[7,sutun]:='P';
  end;
  //siyah            beyaz
  tahta[8,1]:='R';   tahta[1,1]:='R';
  tahta[8,2]:='N';   tahta[1,2]:='N';
  tahta[8,3]:='B';   tahta[1,3]:='B';
  tahta[8,4]:='Q';   tahta[1,4]:='Q';
  tahta[8,5]:='K';   tahta[1,5]:='K';
  tahta[8,6]:='B';   tahta[1,6]:='B';
  tahta[8,7]:='N';   tahta[1,7]:='N';
  tahta[8,8]:='R';   tahta[1,8]:='R';
end;

function TForm1.sutun_bul(yazi:string):byte ;
begin
  if yazi='a' then result:=1;
  if yazi='b' then result:=2;
  if yazi='c' then result:=3;
  if yazi='d' then result:=4;
  if yazi='e' then result:=5;
  if yazi='f' then result:=6;
  if yazi='g' then result:=7;
  if yazi='h' then result:=8;
end;

procedure Tform1.goster();
var
  n,p:byte;
begin
  for n:=1 to 8 do  for p:=1 to 8 do durum.Cells[n-1,p-1]:=' ';
  for p:=1 to 8 do
  for n:=1 to 8 do
  durum.Cells[p-1,n-1]:=tahta[9-p,9-n];
end;

function TForm1.cok_oyun_isle(calisma_sayisi:word):boolean;
var
  a,b:word; tmp:string;
begin
  if not ChBHizliCalis.Checked then application.ProcessMessages;
  if calisma_sayisi=1 then
  begin
    oyunlar.LoadFromFile(ac.FileName); k:=0;
    for a:=0 to oyunlar.Count-1 do
    begin
      tmp:=oyunlar[a];
      oyun_sayisi:=oyun_sayisi+tekrar_sayisi(tmp,';');
      if ((oyun_sayisi mod 4)=0) and (oyun_sayisi<>0) then
      begin
        oyun_sayisi:=0;
        k:=k+1;
        oyun_sirasi[k]:=a;
      end;
    end;
    form1.Caption:='Bulunan oyun says: '+inttostr(k);
  end;
  if k<=1 then lstyahoo.Items:=oyunlar
  else
  begin
    lstyahoo.clear;
    oyun_sirasi[k+1]:=oyunlar.Count-1+5;
    for a:=oyun_sirasi[calisma_sayisi]-3 to oyun_sirasi[calisma_sayisi+1]-5 do
    begin
      try
        lstyahoo.items.add(oyunlar[a]);
      except
        break;
      end;
    end;
    if k>=calisma_sayisi then
    Cevir;
  end;
end;

function TForm1.rok_kontrol(var cumle:string; beyazmi:boolean):boolean;
begin
  case tekrar_sayisi(cumle,'o',false) of
    2:  if beyazmi then
        begin
          tahta[1,5]:=' ';
          tahta[1,8]:=' ';
          tahta[1,7]:='K';
          tahta[1,6]:='R';
          cumle:='O-O';
          result:=true;
        end
        else
        begin
          tahta[8,5]:=' ';
          tahta[8,8]:=' ';
          tahta[8,7]:='K';
          tahta[8,6]:='R';
          cumle:='O-O';
          result:=true;
        end;
    3:  if beyazmi then
        begin
          tahta[1,5]:=' ';
          tahta[1,1]:=' ';
          tahta[1,3]:='K';
          tahta[1,4]:='R';
          cumle:='O-O-O';
          result:=true
        end
        else
        begin
          tahta[8,5]:=' ';
          tahta[8,1]:=' ';
          tahta[8,3]:='K';
          tahta[8,4]:='R';
          cumle:='O-O-O';
          result:=true;
        end;
  else
  result:=false;
  end;
end;

function degisen_piyon(deger:string):string;
var
  ara:string;
  don:char;
begin
  for don:='a' to 'h' do
  begin
    ara:='P'+don+'1';
    if tekrar_sayisi(deger,ara)>0 then
    begin
      insert('=Q',deger,4);
      tahta[strtoint(satir2),sutun2]:='Q';
      result:=deger; exit;
    end;
    ara:='P'+don+'8';
    if tekrar_sayisi(deger,ara)>0 then
    begin
      insert('=Q',deger,4);
      tahta[strtoint(satir2),sutun2]:='Q';
      result:=deger; exit;
    end;
  end;
  result:=deger;
end;

function TForm1.beyaz_hamle(cumle:string):string ;
begin
  if not rok_kontrol(cumle,true) then
  begin
    satir1:=copy(cumle,2,1);
    sutun1:=sutun_bul(copy(cumle,1,1));
    satir2:=copy(cumle,5,1);
    sutun2:=sutun_bul(copy(cumle,4,1));
    tahta[strtoint(satir2),sutun2]:=tahta[strtoint(satir1),sutun1];
    tahta[strtoint(satir1),sutun1]:=' ';
    if tekrar_sayisi(cumle,'x',false)>0 then
    begin
      if tahta[strtoint(satir2),sutun2]='P' then
        hamle:=tahta[strtoint(satir2),sutun2]+copy(cumle,1,1)+'x'+copy(cumle,4,2)
      else
        hamle:=tahta[strtoint(satir2),sutun2]+'x'+copy(cumle,4,2);
    end
    else hamle:=tahta[strtoint(satir2),sutun2]+copy(cumle,4,2);
    if (tahta[strtoint(satir2),sutun2]='R') or (tahta[strtoint(satir2),sutun2]='N') then
    insert(copy(cumle,1,2),hamle,2);
    result:=hamle;
  end
  else result:=cumle;
end;

function TForm1.siyah_hamle(cumle:string):string ;
begin
  if trim(cumle)=''   then begin result:=' '; exit; end;
  if not rok_kontrol(cumle,false) then
  begin
    satir1:=copy(cumle,2,1);
    sutun1:=sutun_bul(copy(cumle,1,1));
    satir2:=copy(cumle,5,1);
    sutun2:=sutun_bul(copy(cumle,4,1));
    tahta[strtoint(satir2),sutun2]:=tahta[strtoint(satir1),sutun1];
    tahta[strtoint(satir1),sutun1]:=' ';
    if tekrar_sayisi(cumle,'x',false)>0 then
    begin
      if tahta[strtoint(satir2),sutun2]='P' then
        hamle:=tahta[strtoint(satir2),sutun2]+copy(cumle,1,1)+'x'+copy(cumle,4,2)
      else
        hamle:=tahta[strtoint(satir2),sutun2]+'x'+copy(cumle,4,2);
    end
    else hamle:=tahta[strtoint(satir2),sutun2]+copy(cumle,4,2);
    if (tahta[strtoint(satir2),sutun2]='R') or (tahta[strtoint(satir2),sutun2]='N') then
    insert(copy(cumle,1,2),hamle,2);
    result:=hamle;
  end
  else result:=cumle;
end;

procedure Tform1.cevir();
var
  say:byte;
  tut,tut1,tut2:string;
begin
  say:=0; //lstdene.Clear;
  baslangic_konumu;
  lstdene.items.Add('[Event "'+'Yahoo Chessgame'+'"]');
  lstdene.items.Add('[Site "'+'Yahoo'+'"]');
  lstdene.items.Add('[Date "'+datetostr(date)+'"]');
  lstdene.items.Add('[Round "-"]');
  lstdene.items.Add('[White "'+copy(lstyahoo.Items[1],8,lstyahoo.Items.Count-8)+'"]');
  lstdene.items.Add('[Black "'+copy(lstyahoo.Items[2],8,lstyahoo.Items.Count-8)+'"]');
  tut1:=lstyahoo.Items[lstyahoo.Items.Count-1];
//Aadaki ksm tam doru almyor olabilir.
  if tekrar_sayisi(tut1,'+',false)>=2 then
  begin
    if length(tut1)<=12 then
    lstdene.items.Add('[Result "1-0"]')
    else lstdene.items.Add('[Result "0-1"]');
  end
  else lstdene.items.Add('[Result "1/2-1/2"]');
  lstdene.items.Add('');
  for i:=5 to lstyahoo.Items.Count-1 do
  begin
    say:=say+1;
    tut:=lstyahoo.Items[i];
    tut:=copy(tut,pos(' ',tut)+1,length(tut)-pos(' ',tut));
    tut1:=beyaz_hamle(copy(tut,1,pos(' ',tut)-1));
    tut1:=degisen_piyon(tut1);
    tut2:=siyah_hamle(copy(tut,pos(' ',tut)+1,length(tut)-pos(' ',tut)));
    tut2:=degisen_piyon(tut2);
    tekrar_sayisi(tut1,'P',true);
    tekrar_sayisi(tut2,'P',true);
    lstdene.Items.Add(inttostr(say)+'. '+tut1+' '+tut2);
    goster;
    if ChkBgoster.Checked then ShowMessagePos(inttostr(say)+'. Hamle',250,200);
  end;
  lstdene.Items[lstdene.Items.Count-1]:=TrimRight(lstdene.Items[lstdene.Items.Count-1])+'#';
  lstdene.Items.Add('');
  calisma:=calisma+1;
  if k>1 then
  cok_oyun_isle(calisma);
end;

procedure TForm1.BtnDonusturClick(Sender: TObject);
begin
  lstdene.Clear;
  cevir;
  btnkaydet.SetFocus;
end;

procedure TForm1.BtnYahooYukleClick(Sender: TObject);
begin
  ac.Execute;
  if ac.FileName<>'' then
  cok_oyun_isle(1);
  btndonustur.SetFocus;
end;

procedure TForm1.BtnKaydetClick(Sender: TObject);
begin
  try
    if chbhizlikaydet.Checked then
      lstdene.Items.SaveToFile(ChangeFileExt(ExtractFileName(ac.FileName),'.pgn'))
    else
    begin
      kaydet.Execute;
      if kaydet.FileName<>'' then
        lstdene.Items.SaveToFile(kaydet.FileName)
      else ShowMessage('Kaydetme ilemi iptal edildi');
    end;
    Application.MessageBox('Kaydetme ilemi baaryla tamamland', 'Bilgi', MB_OK
      +MB_ICONASTERISK+MB_DEFBUTTON1+MB_APPLMODAL);
  except
    Application.MessageBox('Kaydetme ilemi tamamlanmad!', 'Uyar', MB_OK
      +MB_ICONHAND+MB_DEFBUTTON1+MB_APPLMODAL);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  goster;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  oyunlar:=TStringList.Create;
  calisma:=1;
  application.OnException:=Hata;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  oyunlar.Free;
end;

procedure TForm1.BtnTemizleClick(Sender: TObject);
begin
  lstdene.Clear;
end;

end.
